/*----------------------------------------------------------------------------
 Copyright:      Radig Ulrich  mailto: mail@ulrichradig.de
 Author:         Radig Ulrich
 Remarks:        
 known Problems: none
 Version:        23.12.2007
 Description:    RS232 Softuart Routinen (nur Senden)
----------------------------------------------------------------------------*/

#include "softuart.h"

//----------------------------------------------------------------------------
//Softuart init
void softuart_init(void){
	//Port D5 als TX Pin
	PORTD |= (1<<5);
	DDRD |= (1<<5);
	
}

//----------------------------------------------------------------------------
//Ausgabe eines Strings
void uart_write_str(char *str)
{
	while (*str)
	{
		uart_write_char(*str++);
	}
}

//----------------------------------------------------------------------------
//Softuart write char
void uart_write_char(char c){
		unsigned char bit_count = 8;
		//Startbit senden
		PORTD &= ~(1<<5);
		_delay_us(DELAY_TIME);
		
		do
		{
			if (c & 0x01)
			{
				PORTD |= (1<<5);
			}
			else
			{
				PORTD &= ~(1<<5);
			}
			//wait
			_delay_us(DELAY_TIME);
			c = c>>1;
			
		}while(--bit_count);
		//Stopbit wird gesendet
		PORTD |= (1<<5);
		//Warten bis neu gesendet werden kann
		_delay_us(DELAY_TIME);
}


